diff --git a/gcc/builtins.c b/gcc/builtins.c
index dd57b1a..29fc8ef 100644
--- a/gcc/builtins.c
+++ b/gcc/builtins.c
@@ -243,7 +243,7 @@ is_builtin_name (const char *name)
     return true;
   if (strncmp (name, "__atomic_", 9) == 0)
     return true;
-  if (flag_cilkplus 
+  if (GCC_OPTION (flag_cilkplus) 
       && (!strcmp (name, "__cilkrts_detach")   
 	  || !strcmp (name, "__cilkrts_pop_frame")))
     return true;
@@ -2091,7 +2091,7 @@ expand_builtin_mathfn (tree exp, rtx target, rtx subtarget)
       builtin_optab = round_optab; break;
     CASE_FLT_FN (BUILT_IN_NEARBYINT):
       builtin_optab = nearbyint_optab;
-      if (flag_trapping_math)
+      if (GCC_OPTION (flag_trapping_math))
 	break;
       /* Else fallthrough and expand as rint.  */
     CASE_FLT_FN (BUILT_IN_RINT):
@@ -2105,7 +2105,7 @@ expand_builtin_mathfn (tree exp, rtx target, rtx subtarget)
   /* Make a suitable register to place result in.  */
   mode = TYPE_MODE (TREE_TYPE (exp));
 
-  if (! flag_errno_math || ! HONOR_NANS (mode))
+  if (! GCC_OPTION (flag_errno_math) || ! HONOR_NANS (mode))
     errno_set = false;
 
   /* Before working hard, check whether the instruction is available, but try
@@ -2219,7 +2219,7 @@ expand_builtin_mathfn_2 (tree exp, rtx target, rtx subtarget)
 
   result = gen_reg_rtx (mode);
 
-  if (! flag_errno_math || ! HONOR_NANS (mode))
+  if (! GCC_OPTION (flag_errno_math) || ! HONOR_NANS (mode))
     errno_set = false;
 
   if (errno_set && optimize_insn_for_size_p ())
@@ -2465,7 +2465,7 @@ interclass_mathfn_icode (tree arg, tree fndecl)
     }
 
   /* There's no easy way to detect the case we need to set EDOM.  */
-  if (flag_errno_math && errno_set)
+  if (GCC_OPTION (flag_errno_math) && errno_set)
     return CODE_FOR_nothing;
 
   /* Optab mode depends on the mode of the input argument.  */
@@ -2890,14 +2890,14 @@ expand_builtin_int_roundingfn_2 (tree exp, rtx target)
     }
 
   /* There's no easy way to detect the case we need to set EDOM.  */
-  if (flag_errno_math && fallback_fn == BUILT_IN_NONE)
+  if (GCC_OPTION (flag_errno_math) && fallback_fn == BUILT_IN_NONE)
     return NULL_RTX;
 
   /* Make a suitable register to place result in.  */
   mode = TYPE_MODE (TREE_TYPE (exp));
 
   /* There's no easy way to detect the case we need to set EDOM.  */
-  if (!flag_errno_math)
+  if (!GCC_OPTION (flag_errno_math))
     {
       rtx result = gen_reg_rtx (mode);
 
@@ -4586,8 +4586,8 @@ expand_builtin_expect (tree exp, rtx target)
 
   target = expand_expr (arg, target, VOIDmode, EXPAND_NORMAL);
   /* When guessing was done, the hints should be already stripped away.  */
-  gcc_assert (!flag_guess_branch_prob
-	      || optimize == 0 || seen_error ());
+  gcc_assert (!GCC_OPTION (flag_guess_branch_prob)
+	      || GCC_OPTION (optimize) == 0 || seen_error ());
   return target;
 }
 
@@ -4977,7 +4977,7 @@ expand_builtin_fork_or_exec (tree fn, tree exp, rtx target, int ignore)
   tree call;
 
   /* If we are not profiling, just call the function.  */
-  if (!profile_arc_flag)
+  if (!GCC_OPTION (profile_arc_flag))
     return NULL_RTX;
 
   /* Otherwise call the wrapper.  This should be equivalent for the rest of
@@ -5110,7 +5110,7 @@ expand_builtin_sync_operation (enum machine_mode mode, tree exp,
   rtx val, mem;
   location_t loc = EXPR_LOCATION (exp);
 
-  if (code == NOT && warn_sync_nand)
+  if (code == NOT && GCC_OPTION (warn_sync_nand))
     {
       tree fndecl = get_callee_fndecl (exp);
       enum built_in_function fcode = DECL_FUNCTION_CODE (fndecl);
@@ -5277,7 +5277,7 @@ expand_builtin_atomic_exchange (enum machine_mode mode, tree exp, rtx target)
       return NULL_RTX;
     }
 
-  if (!flag_inline_atomics)
+  if (!GCC_OPTION (flag_inline_atomics))
     return NULL_RTX;
 
   /* Expand the operands.  */
@@ -5321,7 +5321,7 @@ expand_builtin_atomic_compare_exchange (enum machine_mode mode, tree exp,
       return NULL_RTX;
     }
   
-  if (!flag_inline_atomics)
+  if (!GCC_OPTION (flag_inline_atomics))
     return NULL_RTX;
 
   /* Expand the operands.  */
@@ -5380,7 +5380,7 @@ expand_builtin_atomic_load (enum machine_mode mode, tree exp, rtx target)
       return NULL_RTX;
     }
 
-  if (!flag_inline_atomics)
+  if (!GCC_OPTION (flag_inline_atomics))
     return NULL_RTX;
 
   /* Expand the operand.  */
@@ -5410,7 +5410,7 @@ expand_builtin_atomic_store (enum machine_mode mode, tree exp)
       return NULL_RTX;
     }
 
-  if (!flag_inline_atomics)
+  if (!GCC_OPTION (flag_inline_atomics))
     return NULL_RTX;
 
   /* Expand the operands.  */
@@ -5448,7 +5448,7 @@ expand_builtin_atomic_fetch_op (enum machine_mode mode, tree exp, rtx target,
   val = expand_expr_force_mode (CALL_EXPR_ARG (exp, 1), mode);
 
   /* Only try generating instructions if inlining is turned on.  */
-  if (flag_inline_atomics)
+  if (GCC_OPTION (flag_inline_atomics))
     {
       ret = expand_atomic_fetch_op (target, mem, val, code, model, fetch_after);
       if (ret)
@@ -5638,7 +5638,7 @@ expand_builtin_atomic_always_lock_free (tree exp)
 static tree
 fold_builtin_atomic_is_lock_free (tree arg0, tree arg1)
 {
-  if (!flag_inline_atomics)
+  if (!GCC_OPTION (flag_inline_atomics))
     return NULL_TREE;
   
   /* If it isn't always lock free, don't generate a result.  */
@@ -5668,7 +5668,7 @@ expand_builtin_atomic_is_lock_free (tree exp)
       return NULL_RTX;
     }
 
-  if (!flag_inline_atomics)
+  if (!GCC_OPTION (flag_inline_atomics))
     return NULL_RTX; 
 
   /* If the value is known at compile time, return the RTX for it.  */
@@ -5799,7 +5799,7 @@ expand_builtin (tree exp, rtx target, rtx subtarget, enum machine_mode mode,
 
   /* When not optimizing, generate calls to library functions for a certain
      set of builtins.  */
-  if (!optimize
+  if (!GCC_OPTION (optimize)
       && !called_as_built_in (fndecl)
       && fcode != BUILT_IN_FORK
       && fcode != BUILT_IN_EXECL
@@ -5883,7 +5883,7 @@ expand_builtin (tree exp, rtx target, rtx subtarget, enum machine_mode mode,
     CASE_FLT_FN (BUILT_IN_SIGNIFICAND):
       /* Treat these like sqrt only if unsafe math optimizations are allowed,
 	 because of possible accuracy problems.  */
-      if (! flag_unsafe_math_optimizations)
+      if (! GCC_OPTION (flag_unsafe_math_optimizations))
 	break;
     CASE_FLT_FN (BUILT_IN_SQRT):
     CASE_FLT_FN (BUILT_IN_FLOOR):
@@ -5904,7 +5904,7 @@ expand_builtin (tree exp, rtx target, rtx subtarget, enum machine_mode mode,
       break;
 
     CASE_FLT_FN (BUILT_IN_ILOGB):
-      if (! flag_unsafe_math_optimizations)
+      if (! GCC_OPTION (flag_unsafe_math_optimizations))
 	break;
     CASE_FLT_FN (BUILT_IN_ISINF):
     CASE_FLT_FN (BUILT_IN_FINITE):
@@ -5948,7 +5948,7 @@ expand_builtin (tree exp, rtx target, rtx subtarget, enum machine_mode mode,
     CASE_FLT_FN (BUILT_IN_SCALB):
     CASE_FLT_FN (BUILT_IN_SCALBN):
     CASE_FLT_FN (BUILT_IN_SCALBLN):
-      if (! flag_unsafe_math_optimizations)
+      if (! GCC_OPTION (flag_unsafe_math_optimizations))
 	break;
 
     CASE_FLT_FN (BUILT_IN_FMOD):
@@ -5967,7 +5967,7 @@ expand_builtin (tree exp, rtx target, rtx subtarget, enum machine_mode mode,
 
     CASE_FLT_FN (BUILT_IN_SIN):
     CASE_FLT_FN (BUILT_IN_COS):
-      if (! flag_unsafe_math_optimizations)
+      if (! GCC_OPTION (flag_unsafe_math_optimizations))
 	break;
       target = expand_builtin_mathfn_3 (exp, target, subtarget);
       if (target)
@@ -5975,7 +5975,7 @@ expand_builtin (tree exp, rtx target, rtx subtarget, enum machine_mode mode,
       break;
 
     CASE_FLT_FN (BUILT_IN_SINCOS):
-      if (! flag_unsafe_math_optimizations)
+      if (! GCC_OPTION (flag_unsafe_math_optimizations))
 	break;
       target = expand_builtin_sincos (exp);
       if (target)
@@ -6829,7 +6829,7 @@ expand_builtin (tree exp, rtx target, rtx subtarget, enum machine_mode mode,
       break;
 
     case BUILT_IN_FREE:
-      if (warn_free_nonheap_object)
+      if (GCC_OPTION (warn_free_nonheap_object))
 	maybe_emit_free_warning (exp);
       break;
 
@@ -7230,10 +7230,10 @@ fold_trunc_transparent_mathfn (location_t loc, tree fndecl, tree arg)
 
   /* If argument is already integer valued, and we don't need to worry
      about setting errno, there's no need to perform rounding.  */
-  if (! flag_errno_math && integer_valued_real_p (arg))
+  if (! GCC_OPTION (flag_errno_math) && integer_valued_real_p (arg))
     return arg;
 
-  if (optimize)
+  if (GCC_OPTION (optimize))
     {
       tree arg0 = strip_float_extensions (arg);
       tree ftype = TREE_TYPE (TREE_TYPE (fndecl));
@@ -7265,11 +7265,11 @@ fold_fixed_mathfn (location_t loc, tree fndecl, tree arg)
 
   /* If argument is already integer valued, and we don't need to worry
      about setting errno, there's no need to perform rounding.  */
-  if (! flag_errno_math && integer_valued_real_p (arg))
+  if (! GCC_OPTION (flag_errno_math) && integer_valued_real_p (arg))
     return fold_build1_loc (loc, FIX_TRUNC_EXPR,
 			TREE_TYPE (TREE_TYPE (fndecl)), arg);
 
-  if (optimize)
+  if (GCC_OPTION (optimize))
     {
       tree ftype = TREE_TYPE (arg);
       tree arg0 = strip_float_extensions (arg);
@@ -7387,7 +7387,7 @@ fold_builtin_cabs (location_t loc, tree arg, tree type, tree fndecl)
 	return fold_build1_loc (loc, ABS_EXPR, type, real);
 
       /* cabs(x+xi) -> fabs(x)*sqrt(2).  */
-      if (flag_unsafe_math_optimizations
+      if (GCC_OPTION (flag_unsafe_math_optimizations)
 	  && operand_equal_p (real, imag, OEP_PURE_SAME))
         {
 	  const REAL_VALUE_TYPE sqrt2_trunc
@@ -7405,8 +7405,8 @@ fold_builtin_cabs (location_t loc, tree arg, tree type, tree fndecl)
     return build_call_expr_loc (loc, fndecl, 1, TREE_OPERAND (arg, 0));
 
   /* Don't do this when optimizing for size.  */
-  if (flag_unsafe_math_optimizations
-      && optimize && optimize_function_for_speed_p (cfun))
+  if (GCC_OPTION (flag_unsafe_math_optimizations)
+      && GCC_OPTION (optimize) && optimize_function_for_speed_p (cfun))
     {
       tree sqrtfn = mathfn_built_in (type, BUILT_IN_SQRT);
 
@@ -7525,7 +7525,7 @@ fold_builtin_sqrt (location_t loc, tree arg, tree type)
 
   /* Optimize sqrt(expN(x)) = expN(x*0.5).  */
   fcode = builtin_mathfn_code (arg);
-  if (flag_unsafe_math_optimizations && BUILTIN_EXPONENT_P (fcode))
+  if (GCC_OPTION (flag_unsafe_math_optimizations) && BUILTIN_EXPONENT_P (fcode))
     {
       tree expfn = TREE_OPERAND (CALL_EXPR_FN (arg), 0);
       arg = fold_build2_loc (loc, MULT_EXPR, type,
@@ -7535,7 +7535,7 @@ fold_builtin_sqrt (location_t loc, tree arg, tree type)
     }
 
   /* Optimize sqrt(Nroot(x)) -> pow(x,1/(2*N)).  */
-  if (flag_unsafe_math_optimizations && BUILTIN_ROOT_P (fcode))
+  if (GCC_OPTION (flag_unsafe_math_optimizations) && BUILTIN_ROOT_P (fcode))
     {
       tree powfn = mathfn_built_in (type, BUILT_IN_POW);
 
@@ -7561,7 +7561,7 @@ fold_builtin_sqrt (location_t loc, tree arg, tree type)
     }
 
   /* Optimize sqrt(pow(x,y)) = pow(|x|,y*0.5).  */
-  if (flag_unsafe_math_optimizations
+  if (GCC_OPTION (flag_unsafe_math_optimizations)
       && (fcode == BUILT_IN_POW
 	  || fcode == BUILT_IN_POWF
 	  || fcode == BUILT_IN_POWL))
@@ -7596,7 +7596,7 @@ fold_builtin_cbrt (location_t loc, tree arg, tree type)
   if ((res = do_mpfr_arg1 (arg, type, mpfr_cbrt, NULL, NULL, 0)))
     return res;
 
-  if (flag_unsafe_math_optimizations)
+  if (GCC_OPTION (flag_unsafe_math_optimizations))
     {
       /* Optimize cbrt(expN(x)) -> expN(x/3).  */
       if (BUILTIN_EXPONENT_P (fcode))
@@ -7760,7 +7760,7 @@ fold_builtin_tan (tree arg, tree type)
 
   /* Optimize tan(atan(x)) = x.  */
   fcode = builtin_mathfn_code (arg);
-  if (flag_unsafe_math_optimizations
+  if (GCC_OPTION (flag_unsafe_math_optimizations)
       && (fcode == BUILT_IN_ATAN
 	  || fcode == BUILT_IN_ATANF
 	  || fcode == BUILT_IN_ATANL))
@@ -7846,7 +7846,7 @@ fold_builtin_cexp (location_t loc, tree arg0, tree type)
 
   /* In case we can easily decompose real and imaginary parts split cexp
      to exp (r) * cexpi (i).  */
-  if (flag_unsafe_math_optimizations
+  if (GCC_OPTION (flag_unsafe_math_optimizations)
       && realp)
     {
       tree rfn, rcall, icall;
@@ -7915,7 +7915,7 @@ fold_builtin_floor (location_t loc, tree fndecl, tree arg)
       REAL_VALUE_TYPE x;
 
       x = TREE_REAL_CST (arg);
-      if (! REAL_VALUE_ISNAN (x) || ! flag_errno_math)
+      if (! REAL_VALUE_ISNAN (x) || ! GCC_OPTION (flag_errno_math))
 	{
 	  tree type = TREE_TYPE (TREE_TYPE (fndecl));
 	  REAL_VALUE_TYPE r;
@@ -7951,7 +7951,7 @@ fold_builtin_ceil (location_t loc, tree fndecl, tree arg)
       REAL_VALUE_TYPE x;
 
       x = TREE_REAL_CST (arg);
-      if (! REAL_VALUE_ISNAN (x) || ! flag_errno_math)
+      if (! REAL_VALUE_ISNAN (x) || ! GCC_OPTION (flag_errno_math))
 	{
 	  tree type = TREE_TYPE (TREE_TYPE (fndecl));
 	  REAL_VALUE_TYPE r;
@@ -7979,7 +7979,7 @@ fold_builtin_round (location_t loc, tree fndecl, tree arg)
       REAL_VALUE_TYPE x;
 
       x = TREE_REAL_CST (arg);
-      if (! REAL_VALUE_ISNAN (x) || ! flag_errno_math)
+      if (! REAL_VALUE_ISNAN (x) || ! GCC_OPTION (flag_errno_math))
 	{
 	  tree type = TREE_TYPE (TREE_TYPE (fndecl));
 	  REAL_VALUE_TYPE r;
@@ -8252,7 +8252,7 @@ fold_builtin_logarithm (location_t loc, tree fndecl, tree arg,
 	return res;
 
       /* Special case, optimize logN(expN(x)) = x.  */
-      if (flag_unsafe_math_optimizations
+      if (GCC_OPTION (flag_unsafe_math_optimizations)
 	  && ((func == mpfr_log
 	       && (fcode == BUILT_IN_EXP
 		   || fcode == BUILT_IN_EXPF
@@ -8267,7 +8267,7 @@ fold_builtin_logarithm (location_t loc, tree fndecl, tree arg,
       /* Optimize logN(func()) for various exponential functions.  We
 	 want to determine the value "x" and the power "exponent" in
 	 order to transform logN(x**exponent) into exponent*logN(x).  */
-      if (flag_unsafe_math_optimizations)
+      if (GCC_OPTION (flag_unsafe_math_optimizations))
 	{
 	  tree exponent = 0, x = 0;
 
@@ -8360,7 +8360,7 @@ fold_builtin_hypot (location_t loc, tree fndecl,
     return fold_build1_loc (loc, ABS_EXPR, type, arg0);
 
   /* hypot(x,x) -> fabs(x)*sqrt(2).  */
-  if (flag_unsafe_math_optimizations
+  if (GCC_OPTION (flag_unsafe_math_optimizations)
       && operand_equal_p (arg0, arg1, OEP_PURE_SAME))
     {
       const REAL_VALUE_TYPE sqrt2_trunc
@@ -8417,7 +8417,7 @@ fold_builtin_pow (location_t loc, tree fndecl, tree arg0, tree arg1, tree type)
 			    build_real (type, dconst1), arg0);
 
       /* Optimize pow(x,0.5) = sqrt(x).  */
-      if (flag_unsafe_math_optimizations
+      if (GCC_OPTION (flag_unsafe_math_optimizations)
 	  && REAL_VALUES_EQUAL (c, dconsthalf))
 	{
 	  tree sqrtfn = mathfn_built_in (type, BUILT_IN_SQRT);
@@ -8427,7 +8427,7 @@ fold_builtin_pow (location_t loc, tree fndecl, tree arg0, tree arg1, tree type)
 	}
 
       /* Optimize pow(x,1.0/3.0) = cbrt(x).  */
-      if (flag_unsafe_math_optimizations)
+      if (GCC_OPTION (flag_unsafe_math_optimizations))
 	{
 	  const REAL_VALUE_TYPE dconstroot
 	    = real_value_truncate (TYPE_MODE (type), dconst_third ());
@@ -8450,7 +8450,7 @@ fold_builtin_pow (location_t loc, tree fndecl, tree arg0, tree arg1, tree type)
 	  if (TREE_CODE (arg0) == REAL_CST
 	      && !TREE_OVERFLOW (arg0)
 	      && (n > 0
-		  || (!flag_trapping_math && !flag_errno_math)
+		  || (!GCC_OPTION (flag_trapping_math) && !GCC_OPTION (flag_errno_math))
 		  || !REAL_VALUES_EQUAL (TREE_REAL_CST (arg0), dconst0)))
 	    {
 	      REAL_VALUE_TYPE x;
@@ -8458,12 +8458,12 @@ fold_builtin_pow (location_t loc, tree fndecl, tree arg0, tree arg1, tree type)
 
 	      x = TREE_REAL_CST (arg0);
 	      inexact = real_powi (&x, TYPE_MODE (type), &x, n);
-	      if (flag_unsafe_math_optimizations || !inexact)
+	      if (GCC_OPTION (flag_unsafe_math_optimizations) || !inexact)
 		return build_real (type, x);
 	    }
 
 	  /* Strip sign ops from even integer powers.  */
-	  if ((n & 1) == 0 && flag_unsafe_math_optimizations)
+	  if ((n & 1) == 0 && GCC_OPTION (flag_unsafe_math_optimizations))
 	    {
 	      tree narg0 = fold_strip_sign_ops (arg0);
 	      if (narg0)
@@ -8472,7 +8472,7 @@ fold_builtin_pow (location_t loc, tree fndecl, tree arg0, tree arg1, tree type)
 	}
     }
 
-  if (flag_unsafe_math_optimizations)
+  if (GCC_OPTION (flag_unsafe_math_optimizations))
     {
       const enum built_in_function fcode = builtin_mathfn_code (arg0);
 
@@ -8590,7 +8590,7 @@ fold_builtin_exponent (location_t loc, tree fndecl, tree arg,
 	return res;
 
       /* Optimize expN(logN(x)) = x.  */
-      if (flag_unsafe_math_optimizations)
+      if (GCC_OPTION (flag_unsafe_math_optimizations))
 	{
 	  const enum built_in_function fcode = builtin_mathfn_code (arg);
 
@@ -9681,7 +9681,7 @@ fold_builtin_fmin_fmax (location_t loc, tree arg0, tree arg1,
 	 These tree codes don't honor that, so only transform if
 	 -ffinite-math-only is set.  C99 doesn't require -0.0 to be
 	 handled, so we don't have to worry about it either.  */
-      if (flag_finite_math_only)
+      if (GCC_OPTION (flag_finite_math_only))
 	return fold_build2_loc (loc, (max ? MAX_EXPR : MIN_EXPR), type,
 			    fold_convert_loc (loc, type, arg0),
 			    fold_convert_loc (loc, type, arg1));
@@ -10299,7 +10299,7 @@ fold_builtin_0 (location_t loc, tree fndecl, bool ignore ATTRIBUTE_UNUSED)
       return fold_builtin_classify_type (NULL_TREE);
 
     case BUILT_IN_UNREACHABLE:
-      if (flag_sanitize & SANITIZE_UNREACHABLE
+      if (GCC_OPTION (flag_sanitize) & SANITIZE_UNREACHABLE
 	  && (current_function_decl == NULL
 	      || !lookup_attribute ("no_sanitize_undefined",
 				    DECL_ATTRIBUTES (current_function_decl))))
@@ -10330,7 +10330,7 @@ fold_builtin_1 (location_t loc, tree fndecl, tree arg0, bool ignore)
 	/* Gimplification will pull the CALL_EXPR for the builtin out of
 	   an if condition.  When not optimizing, we'll not CSE it back.
 	   To avoid link error types of regressions, return false now.  */
-	if (!val && !optimize)
+	if (!val && !GCC_OPTION (optimize))
 	  val = integer_zero_node;
 
 	return val;
@@ -13578,7 +13578,7 @@ do_mpfr_ckconv (mpfr_srcptr m, tree type, int inexact)
      overflow/underflow occurred.  If -frounding-math, proceed iff the
      result of calling FUNC was exact.  */
   if (mpfr_number_p (m) && !mpfr_overflow_p () && !mpfr_underflow_p ()
-      && (!flag_rounding_math || !inexact))
+      && (!GCC_OPTION (flag_rounding_math) || !inexact))
     {
       REAL_VALUE_TYPE rr;
 
@@ -13618,7 +13618,7 @@ do_mpc_ckconv (mpc_srcptr m, tree type, int inexact, int force_convert)
   if (force_convert
       || (mpfr_number_p (mpc_realref (m)) && mpfr_number_p (mpc_imagref (m))
 	  && !mpfr_overflow_p () && !mpfr_underflow_p ()
-	  && (!flag_rounding_math || !inexact)))
+	  && (!GCC_OPTION (flag_rounding_math) || !inexact)))
     {
       REAL_VALUE_TYPE re, im;
 
diff --git a/gcc/builtins.def b/gcc/builtins.def
index 5a76ba3..810aadf 100644
--- a/gcc/builtins.def
+++ b/gcc/builtins.def
@@ -145,7 +145,7 @@ along with GCC; see the file COPYING3.  If not see
 #define DEF_GOMP_BUILTIN(ENUM, NAME, TYPE, ATTRS) \
   DEF_BUILTIN (ENUM, "__builtin_" NAME, BUILT_IN_NORMAL, TYPE, TYPE,    \
                false, true, true, ATTRS, false, \
-	       (flag_openmp || flag_tree_parallelize_loops))
+	       (GCC_OPTION (flag_openmp) || GCC_OPTION (flag_tree_parallelize_loops)))
 
 /* Builtin used by implementation of Cilk Plus.  Most of these are decomposed
    by the compiler but a few are implemented in libcilkrts.  */ 
@@ -159,7 +159,7 @@ along with GCC; see the file COPYING3.  If not see
 #undef DEF_TM_BUILTIN
 #define DEF_TM_BUILTIN(ENUM, NAME, TYPE, ATTRS) \
   DEF_BUILTIN (ENUM, "__builtin_" NAME, BUILT_IN_NORMAL, TYPE, TYPE,    \
-	       true, true, true, ATTRS, false, flag_tm)
+	       true, true, true, ATTRS, false, GCC_OPTION (flag_tm))
 
 /* Builtin used by the implementation of libsanitizer. These
    functions are mapped to the actual implementation of the 
@@ -168,19 +168,19 @@ along with GCC; see the file COPYING3.  If not see
 #define DEF_SANITIZER_BUILTIN(ENUM, NAME, TYPE, ATTRS) \
   DEF_BUILTIN (ENUM, "__builtin_" NAME, BUILT_IN_NORMAL, TYPE, TYPE,    \
 	       true, true, true, ATTRS, true, \
-	      (flag_sanitize & (SANITIZE_ADDRESS | SANITIZE_THREAD \
+	      (GCC_OPTION (flag_sanitize) & (SANITIZE_ADDRESS | SANITIZE_THREAD \
 				| SANITIZE_UNDEFINED)))
 
 #undef DEF_CILKPLUS_BUILTIN
 #define DEF_CILKPLUS_BUILTIN(ENUM, NAME, TYPE, ATTRS)  \
   DEF_BUILTIN (ENUM, NAME, BUILT_IN_NORMAL, BT_FN_INT_VAR, BT_LAST, \
-  	       false, false, false, ATTRS, false, flag_cilkplus) 
+  	       false, false, false, ATTRS, false, GCC_OPTION (flag_cilkplus)) 
 
 /* Define an attribute list for math functions that are normally
    "impure" because some of them may write into global memory for
    `errno'.  If !flag_errno_math they are instead "const".  */
 #undef ATTR_MATHFN_ERRNO
-#define ATTR_MATHFN_ERRNO (flag_errno_math ? \
+#define ATTR_MATHFN_ERRNO (GCC_OPTION (flag_errno_math) ? \
 	ATTR_NOTHROW_LEAF_LIST : ATTR_CONST_NOTHROW_LEAF_LIST)
 
 /* Define an attribute list for math functions that are normally
@@ -189,7 +189,7 @@ along with GCC; see the file COPYING3.  If not see
    check the rounding mode which is akin to examining global
    memory.  */
 #undef ATTR_MATHFN_FPROUNDING
-#define ATTR_MATHFN_FPROUNDING (flag_rounding_math ? \
+#define ATTR_MATHFN_FPROUNDING (GCC_OPTION (flag_rounding_math) ? \
 	ATTR_PURE_NOTHROW_LEAF_LIST : ATTR_CONST_NOTHROW_LEAF_LIST)
 
 /* Define an attribute list for math functions that are normally
@@ -197,7 +197,7 @@ along with GCC; see the file COPYING3.  If not see
    `errno'.  If !flag_errno_math, we can possibly use "pure" or
    "const" depending on whether we care about FP rounding.  */
 #undef ATTR_MATHFN_FPROUNDING_ERRNO
-#define ATTR_MATHFN_FPROUNDING_ERRNO (flag_errno_math ? \
+#define ATTR_MATHFN_FPROUNDING_ERRNO (GCC_OPTION (flag_errno_math) ? \
 	ATTR_NOTHROW_LEAF_LIST : ATTR_MATHFN_FPROUNDING)
 
 /* Define an attribute list for math functions that need to mind FP
@@ -210,7 +210,7 @@ along with GCC; see the file COPYING3.  If not see
 /* Define an attribute list for leaf functions that do not throw
    exceptions normally, but may throw exceptions when using
    -fnon-call-exceptions.  */
-#define ATTR_NOTHROWCALL_LEAF_LIST (flag_non_call_exceptions ? \
+#define ATTR_NOTHROWCALL_LEAF_LIST (GCC_OPTION (flag_non_call_exceptions) ? \
 	ATTR_LEAF_LIST : ATTR_NOTHROW_LEAF_LIST)
 
 /* Make sure 0 is not a legitimate builtin.  */
diff --git a/gcc/c-family/c-ada-spec.c b/gcc/c-family/c-ada-spec.c
index fc21b62..0d60579 100644
--- a/gcc/c-family/c-ada-spec.c
+++ b/gcc/c-family/c-ada-spec.c
@@ -843,14 +843,14 @@ get_ada_package (const char *file)
   else
     base = lbasename (file);
 
-  if (ada_specs_parent == NULL)
+  if (GCC_OPTION (ada_specs_parent) == NULL)
     plen = 0;
   else
-    plen = strlen (ada_specs_parent) + 1;
+    plen = strlen (GCC_OPTION (ada_specs_parent)) + 1;
 
   res = XNEWVEC (char, plen + strlen (base) + 1);
-  if (ada_specs_parent != NULL) {
-    strcpy (res, ada_specs_parent);
+  if (GCC_OPTION (ada_specs_parent) != NULL) {
+    strcpy (res, GCC_OPTION (ada_specs_parent));
     res[plen - 1] = '.';
   }
 
